

* Offsets from ConfigBase for CIS registers
CISREG_COR		EQU	$00
CISREG_CCSR		EQU	$02
CISREG_PRR		EQU	$04
CISREG_SCR		EQU	$06
CISREG_ESR		EQU	$08
CISREG_IOBASE_0		EQU	$0a
CISREG_IOBASE_1		EQU	$0c
CISREG_IOBASE_2		EQU	$0e
CISREG_IOBASE_3		EQU	$10
CISREG_IOSIZE		EQU	$12

*
* Configuration Option Register
*
COR_CONFIG_MASK		EQU	$3f
COR_MFC_CONFIG_MASK	EQU	$38
COR_FUNC_ENA		EQU	$01
COR_ADDR_DECODE		EQU	$02
COR_IREQ_ENA		EQU	$04
COR_LEVEL_REQ		EQU	$40
COR_SOFT_RESET		EQU	$80

*
* Card Configuration and Status Register
*
CCSR_INTR_ACK		EQU	$01
CCSR_INTR_PENDING	EQU	$02
CCSR_POWER_DOWN		EQU	$04
CCSR_AUDIO_ENA		EQU	$08
CCSR_IOIS8		EQU	$20
CCSR_SIGCHG_ENA		EQU	$40
CCSR_CHANGED		EQU	$80

*
* Pin Replacement Register
*
PRR_WP_STATUS		EQU	$01
PRR_READY_STATUS	EQU	$02
PRR_BVD2_STATUS		EQU	$04
PRR_BVD1_STATUS		EQU	$08
PRR_WP_EVENT		EQU	$10
PRR_READY_EVENT		EQU	$20
PRR_BVD2_EVENT		EQU	$40
PRR_BVD1_EVENT		EQU	$80

*
* Socket and Copy Register
*
SCR_SOCKET_NUM		EQU	$0f
SCR_COPY_NUM		EQU	$70

*
* Extended Status Register
*
ESR_REQ_ATTN_ENA	EQU	$01
ESR_REQ_ATTN		EQU	$10

*
* CardBus Function Status Registers
*
CBFN_EVENT		EQU	$00
CBFN_MASK		EQU	$04
CBFN_STATE		EQU	$08
CBFN_FORCE		EQU	$0c

*
* These apply to all the CardBus function registers
*
CBFN_WP			EQU	$0001
CBFN_READY		EQU	$0002
CBFN_BVD2		EQU	$0004
CBFN_BVD1		EQU	$0008
CBFN_GWAKE		EQU	$0010
CBFN_INTR		EQU	$8000

*
* Extra bits in the Function Event Mask Register
*
FEMR_BAM_ENA		EQU	$0020
FEMR_PWM_ENA		EQU	$0040
FEMR_WKUP_MASK		EQU	$4000

